/*
 * Copyright (C) 2019  Max Regan
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

#pragma once

#include "Bsp/macros.h"

#include "Application/ScreenManager.h"
#include "Bsp/Drivers/DisplayDriver.h"
#include "Bsp/ReturnCode.h"
#include "Bsp/Task.h"
#include "Bsp/Time.h"
#include "Bsp/font.h"

class SetDateScreen : public Screen {
public:

    SetDateScreen(BSP::DisplayDriver &display,
                  ScreenManager &m_manager);

    BSP::ReturnCode init();
    BSP::Schedule::NextTime execute() override;

    void enable() override;
    void disable() override;
    void notify_up_button() override;
    void notify_middle_button() override;
    void notify_down_button() override;

private:

    void refresh();
    void render_time();
    void render_selection();
    void display_number(uint32_t *x, uint32_t y, uint32_t tens, uint32_t ones);
    void draw_line(uint32_t x, uint32_t y, uint32_t width);
    uint32_t get_acknak_string_x_pos();
    uint32_t get_acknak_string_len();
    const char *get_acknak_string();


    enum class SetState {
        HOURS,
        MINUTES,
        SECONDS,
        AM_PM,
        ACK_NACK
    };

    BSP::DisplayDriver &m_display;
    ScreenManager &m_manager;

    SetState m_state;
    bool m_is_acked = false;
    BSP::WallClockTime m_time;
    const struct font &m_font;
    const uint32_t m_row_spacing;
    const uint32_t m_row_0_y;
    const uint32_t m_row_1_y;
};
